#include "hash.hpp"
#include "../contrib/xxhash.hpp"
#include <fstream>
#include <sstream>
#include <iomanip>

static std::string to_hex(const void* data, size_t len) {
    const unsigned char* p = static_cast<const unsigned char*>(data);
    std::ostringstream oss;
    for (size_t i = 0; i < len; ++i)
        oss << std::hex << std::setw(2) << std::setfill('0') << (int)p[i];
    return oss.str();
}

std::string hash_data(const std::string& data) {
    auto h = XXH3_128bits(data.data(), data.size());
    return to_hex(&h, sizeof(h));
}

std::string hash_file(const std::string& path) {
    std::ifstream file(path, std::ios::binary);
    if (!file) return "";
    std::ostringstream oss;
    oss << file.rdbuf();
    return hash_data(oss.str());
} 